
--recordes your bag and inventory data
function YGS_BAG_PARSE()
	YGSBAG={}
	for b=0,4 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
				local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YGSBAG[itemID] ~= nil then
					YGSBAG[itemID] = YGSBAG[itemID] + itemCount
				else
					YGSBAG[itemID] = itemCount
				end
			end
		end
	end
	for inv=1,19 do
		if (GetInventoryItemLink("player",inv)) then
			--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
			local itemCount = GetInventoryItemCount("player",inv)
			local itemID = YssGuildShop_itemID_c(GetInventoryItemLink("player",inv))
			if YGSBAG[itemID] ~= nil then
				YGSBAG[itemID] = YGSBAG[itemID] + itemCount
			else
				YGSBAG[itemID] = itemCount
			end
		end
	end
	if YGSBANK ~= nil and YGSBAG ~= nil then
		--YssGuildShop:Print("Merge Scheduled") -- debugline
		YGS_BANK_BAG_MERGE()
	end
end

-- records your bank data
function YGS_BANK_PARSE()
	YGSBANK = {}
	local uniquecheck = 0
	local b = BANK_CONTAINER
        for s=1,GetContainerNumSlots(b) do 
		if (GetContainerItemLink(b,s)) then
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
			local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
			if YGSBANK[itemID] ~= nil then
				YGSBANK[itemID] = YGSBANK[itemID] + itemCount
			else
				YGSBANK[itemID] = itemCount
			end
		end
        end
        for b=5,11 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
				local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YGSBANK[itemID] ~= nil then
					YGSBANK[itemID] = YGSBANK[itemID] + itemCount
				else
					YGSBANK[itemID] = itemCount
				end
			end
		end
        end
end

-- merges bank/bag/inventory data
function YGS_BANK_BAG_MERGE()
	--YssGuildShop:Print("Merging.......") -- debugline
	local YGS_LOCAL_DB = {}
	local uniquecheck = 0
	if YGSBAG ~= nil then
		if YGSBANK ~= nil then
			for itemID, value in pairs(YGSBANK) do
				YssGuildShop_share_value(itemID)
				YGS_LOCAL_DB[itemID] = rawget(YGSBANK, itemID)
				YssGuildShop_item_db(itemID)
			end
			for itemID, value in pairs(YGSBAG) do
				YssGuildShop_share_value(itemID)
				if YGS_LOCAL_DB[itemID] ~= nil then
					YGS_LOCAL_DB[itemID] = "[" .. value .. "/" .. YGS_LOCAL_DB[itemID] .. "/" .. (YGS_LOCAL_DB[itemID] + value) .. "]"
				else
					YssGuildShop_item_db(itemID)
					YGS_LOCAL_DB[itemID] =  "["..YGSBAG[itemID].."/0/"..YGSBAG[itemID].."]"
				end
			end
			for itemID, value in pairs(YGS_LOCAL_DB) do
				--YssGuildShop:Print(value[2])
				if string.gsub (value, "%[.*%]", "true") ~= "true" then
					--YssGuildShop:Print("Fixed: "..key)
					YGS_LOCAL_DB[itemID] = "[0/"..value.."/"..value.."]"
				end
			end
		end
	end
	table.sort(YGS_LOCAL_DB)
	uniquecheck = 0
	YGS_LOCAL_DB["YGS_ID"] = YssGuildShop:ID()
	if YGSDB ~= nil and YGSDB ~= {} then
		for k=1,table.maxn(YGSDB) do
			if YGSDB[k]["YGS_ID"][1] == YGS_LOCAL_DB["YGS_ID"][1] then
				YGSDB[k] = YGS_LOCAL_DB
				uniquecheck = 1
			end
		end
		if uniquecheck == 0 then
			YGSDB[table.maxn(YGSDB)+1] = YGS_LOCAL_DB
		end
	else
		YGSDB = {}
		YGSDB[1] = YGS_LOCAL_DB
	end
	YssGuildShop:Send()
end

--adds items to YGS_share filter and YGS_value
function YssGuildShop_share_value(itemID, value, timestamp)
	if YGS_value[itemID] == nil then
		if value ~= nil then
			YGS_value[itemID] = {value, timestamp}
		else
			YGS_value[itemID] = {}
			YGS_value[itemID][1] = "no value set"
		end
	else
		if YGS_value[itemID][1] == "no value set" then
			if value ~= nil then
				YGS_value[itemID] = {value, timestamp}
			else
				YGS_value[itemID] = {}
				YGS_value[itemID][1] = "no value set"
			end
		elseif YGS_value[itemID][2] < timestamp then
			YGS_value[itemID] = {value, timestamp}
		end
	end
	if YGS_share_filter[itemID] == nil then
		YGS_share_filter[itemID] = rawget(YGS_settings ,2)
	end
end

function YssGuildShop_share_set(bvalue)
	for itemID, value in pairs(YGS_share_filter) do
		YGS_share_filter[itemID] = bvalue
	end
end

--itemID compression decompression and retrival functions
function YssGuildShop_itemID_c(link)
	if not link then return end
	local _, _, itemID, ench, j1, j2, j3, j4, suffixID, uniqueID = string.find(link, "(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)")
	return itemID
end

function YssGuildShop_itemID_d(item)
	if( not item ) then return nil end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(item) 
	return itemName
end

function YssGuildShop_itemID_L(item)
	if( not item ) then return nil end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(item) 
	return itemLink
end

function YssGuildShop_item_db(itemID)
	if YGS_value[itemID] == nil then
		YGS_value[itemID] = {false,""}
	end
end
